<?php
/**
 * ###############################################
 *
 * SWIFT Framework
 * _______________________________________________
 *
 * @author		Gary McGrath
 *
 * @package		SWIFT
 * @copyright	Copyright (c) 2001-2013, Kayako
 * @license		http://www.kayako.com/license
 * @link		http://www.kayako.com
 *
 * ###############################################
 */

class Controller_customtweaks extends Controller_staff
{
	// Core Constants
	const MENU_ID = 2;
	const NAVIGATION_ID = 1;

	/**
	 * Constructor
	 *
	 * @author Varun Shoor
	 * @return bool "true" on Success, "false" otherwise
	 */
	public function __construct()
	{
		parent::__construct();
		return true;
	}

	/**
	 * Destructor
	 *
	 * @author Varun Shoor
	 * @return bool "true" on Success, "false" otherwise
	 */
	public function __destruct()
	{
		parent::__destruct();

		return true;
	}

    public function Moxiecheck($secretpass = '')
    {
    $_SWIFT = SWIFT::GetInstance();
    $_SWIFT_StaffObject = $_SWIFT->Staff;
				if ($_SWIFT_StaffObject instanceof SWIFT_Staff && $_SWIFT_StaffObject->GetIsClassLoaded()) {

// We can use the new editor, as the logged in user is staff!
echo $secretpass;
                }


    }

      	public function HistoryOrganization($_OrgID) {

		SWIFT_Loader::LoadLibrary('Flag:TicketFlag', APP_TICKETS, false);
		SWIFT_Loader::LoadLibrary('SLA:SLAHolidayManager', APP_TICKETS, false);

		// Ticket Models
		SWIFT_Loader::LoadModel('SLA:SLA', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('SLA:SLASchedule', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('SLA:SLAHoliday', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('Status:TicketStatus', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('Priority:TicketPriority', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('FileType:TicketFileType', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('Link:TicketLinkType', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('Type:TicketType', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('Bayesian:BayesianCategory', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('View:TicketView', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('View:TicketViewField', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('View:TicketViewLink', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('Workflow:TicketWorkflow', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('Escalation:EscalationRule', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('Filter:TicketFilter', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('Filter:TicketFilterField', APP_TICKETS, false);
		SWIFT_Loader::LoadModel('AutoClose:AutoCloseRule', APP_TICKETS, false);
        SWIFT_Loader::LoadLibrary('Ticket:TicketManager', APP_TICKETS);

		SWIFT_Loader::LoadModel('Ticket:Ticket', APP_TICKETS);
		SWIFT_Loader::LoadModel('Ticket:TicketPost', APP_TICKETS);
		SWIFT_Loader::LoadModel('Note:TicketNoteManager', APP_TICKETS);

        $this->Language->Load('staff_ticketsmain');
		$this->Language->Load('staff_ticketsmanage');


		$_SWIFT = SWIFT::GetInstance();

		if (!$this->GetIsClassLoaded()) {
			throw new SWIFT_Exception(SWIFT_CLASSNOTLOADED);

			return false;
		}


        $_departmentCache = $_SWIFT->Cache->Get('departmentcache');
		$_ticketStatusCache = $_SWIFT->Cache->Get('statuscache');
		$_ticketPriorityCache = $_SWIFT->Cache->Get('prioritycache');
		$_ticketTypeCache = $_SWIFT->Cache->Get('tickettypecache');
        $_historyCount = 0;
		$_historyContainer = array();
        $_renderHTML = '<table width="100%" cellspacing="0" cellpadding="4" border="0">';
		$_renderHTML .= '<tbody><tr class=""><td valign="middle" align="left" class="gridtabletitlerow" width="16">&nbsp;</td><td valign="middle" align="left" class="gridtabletitlerow" width="120">' . $this->Language->Get('history_ticketid') . '</td><td valign="middle" align="left" class="gridtabletitlerow">' . $this->Language->Get('history_subject') . '</td><td valign="middle" align="center" class="gridtabletitlerow" width="160">' . $this->Language->Get('history_date') . '</td><td valign="middle" align="center" class="gridtabletitlerow" width="120">' . $this->Language->Get('history_department') . '</td><td valign="middle" align="center" class="gridtabletitlerow" width="120">User</td><td valign="middle" align="center" class="gridtabletitlerow" width="90">' . $this->Language->Get('history_type') . '</td><td valign="middle" align="center" class="gridtabletitlerow" width="100">' . $this->Language->Get('history_status') . '</td><td valign="middle" align="center" class="gridtabletitlerow" width="90">' . $this->Language->Get('history_priority') . '</td></tr>';

		$_ticketSortBy = 'dateline';
		$_ticketSortOrder = 'DESC';
		if (!empty($_sortBy) && !empty($_sortOrder))
		{
			$_ticketSortBy = $_sortBy;
			$_ticketSortOrder = $_sortOrder;
		}

		$_SWIFT->Database->Query("SELECT * FROM " . TABLE_PREFIX . "tickets WHERE userid In (select userid from " . TABLE_PREFIX . "users where userorganizationid = '" . intval($_OrgID) ."')  ORDER BY " . $_ticketSortBy . " " . $_ticketSortOrder);
		while ($_SWIFT->Database->NextRecord()) {
			$_historyContainer[$_SWIFT->Database->Record['ticketid']] = new SWIFT_Ticket(new SWIFT_DataStore($_SWIFT->Database->Record));
		}




foreach ($_historyContainer as $_ticketID => $_TicketObject_History) {

			$_historyCount++;

			$_ticketURL = $_UserNameHTML = $_ticketURLPrefix = $_ticketURLSuffix = $_departmentHTML = $_typeHTML = $_statusHTML = $_priorityHTML = $_statusStyle = $_priorityStyle = '';

			$_ticketIcon = 'icon_ticket.png';
			if (!$_TicketObject_History->CanAccess($_SWIFT->Staff)) {
				$_ticketIcon = 'icon_lock.gif';
			} else {
				$_ticketURL = SWIFT::Get('basename') . '/Tickets/Ticket/View/' . intval($_TicketObject_History->GetTicketID());
				$_ticketURLPrefix = '<a href="' . $_ticketURL . '" viewport="1">';
				$_ticketURLSuffix = '</a>';
			}
			$_ticketIconHTML = '<img src="' . SWIFT::Get('themepath') . 'images/' . $_ticketIcon . '" align="absmiddle" border="0" />';

			// Department
			if (isset($_departmentCache[$_TicketObject_History->GetProperty('departmentid')])) {
				$_departmentHTML = htmlspecialchars(StripName($_departmentCache[$_TicketObject_History->GetProperty('departmentid')]['title'], 15));
			} else {
				$_departmentHTML = $_SWIFT->Language->Get('na');
			}

			// Ticket Status
			if (isset($_ticketStatusCache[$_TicketObject_History->GetProperty('ticketstatusid')])) {
				$_ticketStatusContainer = $_ticketStatusCache[$_TicketObject_History->GetProperty('ticketstatusid')];
				$_displayIconImage = '';
				if (!empty($_ticketStatusContainer['displayicon'])) {
					$_displayIconImage = '<img src="' . ProcessDisplayIcon($_ticketStatusContainer['displayicon']) .
							'" align="absmiddle" border="0" /> ';
				}

				$_statusHTML = $_displayIconImage . htmlspecialchars(StripName($_ticketStatusContainer['title'], 15));
				$_statusStyle = 'background-color: ' . $_ticketStatusContainer['statusbgcolor'] . '; color: ' .
						$_ticketStatusContainer['statuscolor'];
			} else {
				$_statusHTML = $_SWIFT->Language->Get('na');
			}

			// Ticket Priority
			if (isset($_ticketPriorityCache[$_TicketObject_History->GetProperty('priorityid')])) {
				$_ticketPriorityContainer = $_ticketPriorityCache[$_TicketObject_History->GetProperty('priorityid')];
				$_displayIconImage = '';
				if (!empty($_ticketPriorityContainer['displayicon'])) {
					$_displayIconImage = '<img src="' . ProcessDisplayIcon($_ticketPriorityContainer['displayicon']) .
							'" align="absmiddle" border="0" /> ';
				}

				$_priorityHTML = $_displayIconImage . htmlspecialchars(StripName($_ticketPriorityContainer['title'], 15));
				$_priorityStyle = 'background-color: ' . $_ticketPriorityContainer['bgcolorcode'] . '; color: ' .
						$_ticketPriorityContainer['frcolorcode'] . ';';
			} else {
				$_priorityHTML = $_SWIFT->Language->Get('na');
			}

			// Ticket Type
			if (isset($_ticketTypeCache[$_TicketObject_History->GetProperty('tickettypeid')])) {
				$_ticketTypeContainer = $_ticketTypeCache[$_TicketObject_History->GetProperty('tickettypeid')];
				$_displayIconImage = '';
				if (!empty($_ticketTypeContainer['displayicon'])) {
					$_displayIconImage = '<img src="' . ProcessDisplayIcon($_ticketTypeContainer['displayicon']) .
							'" align="absmiddle" border="0" /> ';
				}

				$_typeHTML = $_displayIconImage . htmlspecialchars(StripName($_ticketTypeContainer['title'], 15));
			} else {
				$_typeHTML = $_SWIFT->Language->Get('na');
			}

			$_UserNameHTML = htmlspecialchars(StripName($_TicketObject_History->GetProperty('fullname'), 15));


			$_renderHTML .= '<tr class="tablerow1_tr"><td valign="middle" align="center" class="tablerow1">' . $_ticketIconHTML . '</td>';
			$_renderHTML .= '<td valign="middle" align="left" class="tablerow1">' . $_ticketURLPrefix . $_TicketObject_History->GetTicketDisplayID() . $_ticketURLSuffix . '</td>';
			$_renderHTML .= '<td valign="middle" align="left" class="tablerow1">' . $_ticketURLPrefix . htmlspecialchars($_TicketObject_History->GetProperty('subject')) . $_ticketURLSuffix . '</td>';
			$_renderHTML .= '<td valign="middle" align="center" class="tablerow1">' . SWIFT_Date::Get(SWIFT_Date::TYPE_DATETIME, $_TicketObject_History->GetProperty('dateline')) . '</td>';
			$_renderHTML .= '<td valign="middle" align="center" class="tablerow1">' . $_departmentHTML . '</td>';
			$_renderHTML .= '<td valign="middle" align="center" class="tablerow1">' . $_UserNameHTML . '</td>';
            $_renderHTML .= '<td valign="middle" align="center" class="tablerow1">' . $_typeHTML . '</td>';
			$_renderHTML .= '<td valign="middle" align="center" class="tablerow1">' . $_statusHTML . '</td>';
			$_renderHTML .= '<td valign="middle" align="center" class="tablerow1" style="' . $_priorityStyle . '">' . $_priorityHTML . '</td>';
			$_renderHTML .= '</tr>';
		}

		if ($_historyCount == 0) {
			$_renderHTML .= '<tr class="tablerow1_tr"><td valign="middle" align="left" class="tablerow1" colspan="9">' . $this->Language->Get('noinfoinview') . '</td></tr>';
		}

		$_renderHTML .= '</tbody></table>';

		echo $_renderHTML;
	}

}
?>